<!DOCTYPE html>

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Laporan Absen</title>
  <style>
    #kepala-laporan {
      text-align: center;
    }
  </style>
</head>

<body>
  <div id="kepala-laporan">
    <h3 id="jenis"></h1>
    <h3 id="cabang"></h1>
    <h3 id="keterangan"></h1>
  </div>
  <div id="laporan"></div>  

  <script>
    function tampilkanLaporan() {
      const query = new URLSearchParams(window.location.search);

      const tahun = query.get('tahun');
      const bulan = query.get('bulan');
      const absensi = query.get('absensi');

      fetch('/absensi')
        .then(value => value.json())
        .then(dataAbsensi => {
          const dbAbsensi = dataAbsensi.find(abs => abs.id == absensi);

          document.querySelector('#jenis').append(dbAbsensi.jenis);
          document.querySelector('#cabang').append(dbAbsensi.cabang);
          document.querySelector('#keterangan').append(dbAbsensi.keterangan);
        })
  
      fetch(`/laporan?tahun=${tahun}&bulan=${bulan}&absensi=${absensi}`)
        .then(value => value.json())
        .then(laporan => {
          const jumlahHari = tanggalTerakhirDari(tahun, bulan);
  
          fetch(`/libur?tahun=${tahun}&bulan=${bulan}`)
            .then(value => value.json())
            .then(hariIstimewa => {
              buatTabelLaporan(laporan, jumlahHari, hariIstimewa);
            })
        })
    }
  
    function buatTabelLaporan(laporan, jumlahHari, hariIstimewa) {
      const tabelLaporan = document.createElement('table');
      const fieldLaporan = document.querySelector('#laporan');
      tabelLaporan.border = 1;
      tabelLaporan.style.borderCollapse = 'collapse';
      tabelLaporan.cellPadding = '7px';
  
      const rangeTanggal = range(1, jumlahHari);
  
      tambahBaris(tabelLaporan, ['NIP', 'Nama', 'Jabatan', ...rangeTanggal], true);
      
      const dataLibur = hariIstimewa.map(libur => {
        libur.tanggal = new Date(libur.tanggal).getDate();
        return libur;
      })
  
      laporan.forEach(pegawai => {
        const {nip, nama, jabatan, data_absen} = pegawai;
  
        const dataAbsen = data_absen.map(absen => {
          const {tanggal, waktu, keterangan} = absen;
  
          const tanggalAbsen = new Date(absen.tanggal).getDate();
          const absensi = keterangan || waktu.slice(0, waktu.length - 3);
  
          return {
            tanggal: tanggalAbsen,
            absensi,
          };
        });
  
        const laporanAbsen = [...Array(jumlahHari)].map((_, index) => {
          const tanggal = index + 1;
          const hariLibur = dataLibur.find(libur => libur.tanggal === tanggal);
  
          if (hariLibur) {
            return hariLibur.keterangan;
          }
  
          const absenDitemukan = dataAbsen.find(absen => absen.tanggal === tanggal);
  
          if (absenDitemukan) {
            return absenDitemukan.absensi;
          } else {
            return '';
          }
        });
  
        tambahBaris(tabelLaporan, [nip || '', nama, jabatan, ...laporanAbsen]);
      });
  
      while (fieldLaporan.lastChild) {
        fieldLaporan.removeChild(fieldLaporan.lastChild);
      }
  
      fieldLaporan.append(tabelLaporan);
    }
  
    function tambahBaris(tabel, data, kepala=false) {
      const body = document.createElement('tbody');
      const baris = document.createElement('tr');
      tabel.append(body);
      body.append(baris);
  
      data.forEach(text => {
        const kolom = document.createElement(kepala ? 'th' : 'td');
        kolom.append(text);
        baris.append(kolom);
      })
    }
    
    function range(from, end) {
      return [...Array(end).keys()].map(i => i + from);
    }
  
    function tanggalTerakhirDari(tahun, bulan) {
      return new Date(tahun, bulan, 0).getDate();
    }

    tampilkanLaporan();
  </script>
</body>

</html>